#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

int n;
vector< pair<int,int> > a[1 << 20];
int d[1 << 20];
priority_queue<pair<int, int> > pq;

void read() {
    scanf("%d", &n);
    for (int i = 2; i <= n; i++) {
        int p, c;
        
        scanf("%d%d", &p, &c);
        a[p].push_back(make_pair(i, c));
        a[i].push_back(make_pair(p, c));
    }
}

void psh(int x, int y) {
    if (d[x] > y) {
        d[x] = y;
        pq.push(make_pair(-y, x));
    }
}

int dijkstra(int st, int to, int q, int w, int e) {
    while (!pq.empty()) pq.pop();
    for (int i = 1; i <= n; i++) {
        d[i] = 1 << 30;
    }
    
    psh(st, 0);
    
    while (!pq.empty()) {
        int x = pq.top().second;
        int c = -pq.top().first;
        pq.pop();
        
        if (x == to) {
            return c;
        }
        
        if (d[x] < c) continue;
        
        for (int i = 0; i < (int)a[x].size(); i++) {
            psh(a[x][i].first, c + a[x][i].second);
        }
        if (x == q) psh(w, c + e);
        if (x == w) psh(q, c + e);
    }
    
    return 1 << 30;
}

void solve() {
    int q;
    
    scanf ("%d", &q);
    while (q --) {
        int x, y, t;
        
        scanf("%d%d%d", &x, &y, &t);
        int ans = 1 << 30;
        
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                ans = min(ans, dijkstra(1, x, i, j, t) + dijkstra(x, y, i, j, t));
            }
        }
        
        printf ("%d\n", ans);
    }
}

int main() {
    read();
    solve();
    
    return 0;
}
